import { ITokenRequestCreateOne, ITokenRequestFindOneByAutoGeneretedToken } from '../common/interfaces/requests/token.request';
import { Token } from '../models/token.model';

export const validateTokenCreateOne = (token: ITokenRequestCreateOne) => {
  const isValidCvv = validateCVV(token.cvv);

  if (!isValidCvv) {
    const result = {
      isValid: false,
      message: 'Not valid CVV',
    };

    return result;
  }

  const isValidEmail = validateEmail(token.email);

  if (!isValidEmail) {
    const result = {
      isValid: false,
      message: 'Not valid email',
    };

    return result;
  }

  const isValidCardNumber = validateCardNumber(token.card_number);

  if (!isValidCardNumber) {
    const result = {
      isValid: false,
      message: 'Not valid card number',
    };

    return result;
  }

  const isValidExpirationMonth = validateExpirationMonth(token.expiration_month);

  if (!isValidExpirationMonth) {
    const result = {
      isValid: false,
      message: 'Not valid expiration month',
    };

    return result;
  }

  const isValidExpirationYear = validateExpirationYear(token.expiration_year);

  if (!isValidExpirationYear) {
    const result = {
      isValid: false,
      message: 'Not valid expiration year',
    };

    return result;
  }

  const isValidToken =
    isValidCvv && isValidEmail && isValidCardNumber && isValidExpirationMonth && isValidExpirationYear;

  const result = {
    isValid: isValidToken,
    message: 'Token valid',
  };

  return result;
};

export const validateCVV = (cvv: number) => {
  const cvvString = cvv.toString();
  const cvvLength = cvvString.length;
  const validCVV = cvvLength == 3 || cvvLength == 4;
  return validCVV;
};

export const validateEmail = (email: string) => {
  const regex = /^[a-zA-Z0-9._-]{5,100}@(?:gmail\.com|hotmail\.com|yahoo\.es)$/;
  const validEmail = regex.test(email);
  return validEmail;
};

export const validateCardNumber = (cardNumber: number) => {
  const cardNumberString = cardNumber.toString();

  const cardLength = cardNumberString.length;
  const validLength = 13 <= cardLength && cardLength <= 16;

  if (!validLength) return false;

  let sumLuhn = 0;
  let isAlternativeDigit = false;

  for (let i = cardLength - 1; i >= 0; i--) {
    const cardChar = cardNumberString.charAt(i);
    let digit = parseInt(cardChar, 10);

    if (isAlternativeDigit) {
      digit *= 2;

      if (digit > 9) digit -= 9;
    }

    sumLuhn += digit;
    isAlternativeDigit = !isAlternativeDigit;
  }

  const isValidCardNumber = sumLuhn % 10 == 0;
  return isValidCardNumber;
};

export const validateExpirationMonth = (expiration_month: string) => {
  const expirationMonthNumber = +expiration_month;

  const regex = new RegExp('[^0-9-s]');
  const isValidRegex = regex.test(expiration_month);

  if (!isValidRegex) false;

  const isGreaterOrEqualThanOne = 1 <= expirationMonthNumber;
  const isLowerOrEqualThanTwelve = expirationMonthNumber <= 12;

  const isValidExpirationMonth = isGreaterOrEqualThanOne && isLowerOrEqualThanTwelve;

  return isValidExpirationMonth;
};

export const validateExpirationYear = (expiration_year: string) => {
  const currentDate = new Date();
  const currentYear = currentDate.getFullYear();
  const maxYear = currentYear + 5;

  const expirationYearNumber = +expiration_year;

  const regex = new RegExp('[^0-9-s]');
  const isValidRegex = regex.test(expiration_year);

  if (!isValidRegex) false;

  const isCorrectLength = expiration_year.length == 4;
  const isGreaterOrEqualThanMaxYear = expirationYearNumber <= maxYear;
  const isLowerOrEqualThanCurrentYeat = currentYear < expirationYearNumber;

  const isValidExpirationYear = isGreaterOrEqualThanMaxYear && isLowerOrEqualThanCurrentYeat && isCorrectLength;

  return isValidExpirationYear;
};

export const validateTokenFindOneByAutoGeneratedToken = (query: ITokenRequestFindOneByAutoGeneretedToken) => {
  const { token } = query

  const isValidToken = validateToken(token)

  if (!isValidToken) {
    const result = {
      isValid: false,
      message: 'Not valid token',
    };

    return result;
  }

  const isValid = isValidToken

  const result = {
    isValid: isValid,
    message: 'Valid token'
  }

  return result
}

export const validateToken = (token: string) => {
  const isCorrectLength = token.length == 16
  return isCorrectLength
}

export const isExpiredToken = (token: Token) => {
  const { expiration_date_token } = token

  const expirationDateToken = new Date(expiration_date_token)
  const currentDate = new Date()

  const isExpired = expirationDateToken < currentDate
  return isExpired
}